#line 1 "C:/Projects/WebServer/websvr.c"
#line 1 "c:/c4w/mikroelektronika/mikroc pro for arm/packages/network_ethernet_arm/uses/__netethinternal.h"
#line 33 "c:/c4w/mikroelektronika/mikroc pro for arm/packages/network_ethernet_arm/uses/__netethinternal.h"
typedef struct
 {
 unsigned char valid;
 unsigned long tmr;
 unsigned char ip[4];
 unsigned char mac[6];
 } Net_Ethernet_Intern_arpCacheStruct;

extern Net_Ethernet_Intern_arpCacheStruct Net_Ethernet_Intern_arpCache[];

extern unsigned char Net_Ethernet_Intern_macAddr[6];
extern unsigned char Net_Ethernet_Intern_ipAddr[4];
extern unsigned char Net_Ethernet_Intern_gwIpAddr[4];
extern unsigned char Net_Ethernet_Intern_ipMask[4];
extern unsigned char Net_Ethernet_Intern_dnsIpAddr[4];
extern unsigned char Net_Ethernet_Intern_rmtIpAddr[4];

extern unsigned long Net_Ethernet_Intern_userTimerSec;




typedef struct {
 char remoteIP[4];
 char remoteMAC[6];
 unsigned int remotePort;
 unsigned int destPort;
 unsigned int dataLength;
 unsigned int broadcastMark;
} UDP_Intern_Dsc;


extern UDP_Intern_Dsc udpRecord_Intern;




typedef struct {
 char remoteIP[4];
 char remoteMAC[6];
 unsigned int remotePort;
 unsigned int destPort;

 unsigned int dataLength;
 unsigned int remoteMSS;
 unsigned int myWin;
 unsigned int myMSS;
 unsigned long mySeq;
 unsigned long myACK;

 char stateTimer;
 char retransmitTimer;
 unsigned int packetID;
 char open;
 char ID;
 char broadcastMark;
 char state;









 unsigned int nextSend;
 unsigned int lastACK;
 unsigned int lastSent;
 unsigned int lastWritten;
 unsigned int numToSend;
 char buffState;
 char *txBuffer;


} SOCKET_Intern_Dsc;
#line 127 "c:/c4w/mikroelektronika/mikroc pro for arm/packages/network_ethernet_arm/uses/__netethinternal.h"
extern const char NUM_OF_SOCKET_Intern;
extern const unsigned int TCP_TX_SIZE_Intern;
extern const unsigned int MY_MSS_Intern;
extern const unsigned int SYN_FIN_WAIT_Intern;
extern const unsigned int RETRANSMIT_WAIT_Intern;

extern char tx_buffers_Intern[][];
extern SOCKET_Intern_Dsc socket_Intern[];
#line 139 "c:/c4w/mikroelektronika/mikroc pro for arm/packages/network_ethernet_arm/uses/__netethinternal.h"
extern void Net_Ethernet_Intern_Init(unsigned char *mac, unsigned char *ip, unsigned long configuration);
extern unsigned char Net_Ethernet_Intern_doPacket();
extern void Net_Ethernet_Intern_putByte(unsigned char b);
extern void Net_Ethernet_Intern_putBytes(unsigned char *ptr, unsigned int n);
extern void Net_Ethernet_Intern_putConstBytes(const unsigned char *ptr, unsigned int n);
extern unsigned char Net_Ethernet_Intern_getByte();
extern void Net_Ethernet_Intern_getBytes(unsigned char *ptr, unsigned long addr, unsigned int n);
extern unsigned int Net_Ethernet_Intern_UserUDP(UDP_Intern_Dsc *udpDsc);
extern void Net_Ethernet_Intern_payloadInitUDP();
extern void Net_Ethernet_Intern_UserTCP(SOCKET_Intern_Dsc *socket);
extern void Net_Ethernet_Intern_confNetwork(char *ipMask, char *gwIpAddr, char *dnsIpAddr);

extern char Net_Ethernet_Intern_connectTCP(char *remoteIP, unsigned int remote_port ,unsigned int my_port, SOCKET_Intern_Dsc **used_socket);
extern char Net_Ethernet_Intern_disconnectTCP(SOCKET_Intern_Dsc *socket);
extern char Net_Ethernet_Intern_resetSocket(SOCKET_Intern_Dsc *socket_Intern);
extern unsigned int Net_Ethernet_Intern_bufferFreeSize(SOCKET_Intern_Dsc *socket_Intern);

extern char Net_Ethernet_Intern_putByteTCP(char ch, SOCKET_Intern_Dsc *socket);
extern unsigned int Net_Ethernet_Intern_putBytesTCP(char *ptr,unsigned int n, SOCKET_Intern_Dsc *socket);
extern unsigned int Net_Ethernet_Intern_putConstBytesTCP(const char *ptr,unsigned int n, SOCKET_Intern_Dsc *socket);
extern unsigned int Net_Ethernet_Intern_putStringTCP(char *ptr, SOCKET_Intern_Dsc *socket);
extern unsigned int Net_Ethernet_Intern_putConstStringTCP(const char *ptr, SOCKET_Intern_Dsc *socket);
extern char Net_Ethernet_Intern_bufferEmptyTCP(SOCKET_Intern_Dsc *socket);
extern void Net_Ethernet_Intern_stackInitTCP();
extern char Net_Ethernet_Intern_startSendTCP(SOCKET_Intern_Dsc *socket);
#line 1 "c:/c4w/mikroelektronika/mikroc pro for arm/packages/stm_dma/uses/dma_mem.h"
#line 1 "c:/c4w/mikroelektronika/mikroc pro for arm/include/stdbool.h"






 typedef int _Bool;
#line 1 "c:/c4w/mikroelektronika/mikroc pro for arm/include/stdint.h"





typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 12 "c:/c4w/mikroelektronika/mikroc pro for arm/packages/stm_dma/uses/dma_mem.h"
typedef enum {
 CHANNEL_0 = 1,
 CHANNEL_1,
 CHANNEL_2,
 CHANNEL_3,
 CHANNEL_4,
 CHANNEL_5,
 CHANNEL_6,
 CHANNEL_7
} dma_channel_t;
#line 30 "c:/c4w/mikroelektronika/mikroc pro for arm/packages/stm_dma/uses/dma_mem.h"
void dma_mem_init( dma_channel_t channel, uint8_t priority );
#line 44 "c:/c4w/mikroelektronika/mikroc pro for arm/packages/stm_dma/uses/dma_mem.h"
void dma_mem_cpy( void* dst, void* src, uint16_t size );
#line 55 "c:/c4w/mikroelektronika/mikroc pro for arm/packages/stm_dma/uses/dma_mem.h"
 _Bool  is_dma_mem_finished( void );
#line 62 "c:/c4w/mikroelektronika/mikroc pro for arm/packages/stm_dma/uses/dma_mem.h"
void dma_mem_complete( void );
#line 1 "c:/projects/webserver/bargraph.h"
#line 1 "c:/c4w/mikroelektronika/mikroc pro for arm/include/stdint.h"
#line 6 "c:/projects/webserver/bargraph.h"
void bar_graph_init( uint8_t spi_channel );
void bar_graph_display( uint8_t digit );
#line 1 "c:/projects/webserver/websvr.h"
#line 1 "c:/c4w/mikroelektronika/mikroc pro for arm/include/stdint.h"
#line 1 "c:/c4w/mikroelektronika/mikroc pro for arm/include/stdbool.h"
#line 1 "c:/c4w/mikroelektronika/mikroc pro for arm/include/stddef.h"



typedef long ptrdiff_t;
typedef unsigned long size_t;
typedef unsigned long wchar_t;
#line 74 "c:/projects/webserver/websvr.h"
typedef struct
{

 char key[ 25 ];

 char value[ 25 ];
} key_value_t;


struct webserver_config_t
{

 char myMacAddr[6];

 char myIpAddr [4];

 char gwIpAddr [4];

 char ipMask [4];

 char dnsIpAddr[4];

 uint16_t port;

 uint32_t epochTime;

 void ( *form_key_values )( key_value_t *values );

 void ( *file_download )( char *fileName );

 void ( *ntp_time )( uint32_t time );

  _Bool  irq_enable;
};
#line 117 "c:/projects/webserver/websvr.h"
int8_t webserver_init( struct webserver_config_t* config );
#line 125 "c:/projects/webserver/websvr.h"
void webserver_read_packet( void );
#line 133 "c:/projects/webserver/websvr.h"
int8_t webserver_request_NTP( char* const ntpSrv );
#line 144 "c:/projects/webserver/websvr.h"
int8_t webserver_request_file( char* const request, uint16_t port );
#line 153 "c:/projects/webserver/websvr.h"
void webserver_cleanup( void );
#line 161 "c:/projects/webserver/websvr.h"
void webserver_time_update( void );
#line 174 "c:/projects/webserver/websvr.h"
int8_t webserver_add_staticpage( const char* page, char* page_name, long page_size );
#line 189 "c:/projects/webserver/websvr.h"
int8_t webserver_add_dynamicpage( char* const page, char* page_name, void ( *page_upd_callback )( void ) );


void webserver_print_status( void );
#line 1 "c:/c4w/mikroelektronika/mikroc pro for arm/include/built_in.h"
#line 1 "c:/c4w/mikroelektronika/mikroc pro for arm/packages/fat32 library/uses/__lib_fat32.h"
#line 29 "c:/c4w/mikroelektronika/mikroc pro for arm/packages/fat32 library/uses/__lib_fat32.h"
typedef unsigned short uint8;
typedef signed short int8;
typedef unsigned int uint16;
typedef signed int int16;
typedef unsigned long uint32;
typedef signed long int32;
typedef unsigned long long uint64;
typedef signed long long int64;

static const uint16 SECTOR_SIZE = 512;









static const uint8
 FILE_READ = 0x01,
 FILE_WRITE = 0x02,
 FILE_APPEND = 0x04;






static const uint8
 ATTR_NONE = 0x00,
 ATTR_READ_ONLY = 0x01,
 ATTR_HIDDEN = 0x02,
 ATTR_SYSTEM = 0x04,
 ATTR_VOLUME_ID = 0x08,
 ATTR_DIRECTORY = 0x10,
 ATTR_ARCHIVE = 0x20,
 ATTR_DEVICE = 0x40,

 ATTR_RESERVED = 0x80;

static const uint8
 ATTR_LONG_NAME = ATTR_READ_ONLY |
 ATTR_HIDDEN |
 ATTR_SYSTEM |
 ATTR_VOLUME_ID;

static const uint8
 ATTR_FILE_MASK = ATTR_READ_ONLY |
 ATTR_HIDDEN |
 ATTR_SYSTEM |
 ATTR_ARCHIVE,

 ATTR_LONG_NAME_MASK = ATTR_READ_ONLY |
 ATTR_HIDDEN |
 ATTR_SYSTEM |
 ATTR_VOLUME_ID |
 ATTR_DIRECTORY |
 ATTR_ARCHIVE;






static const int8



 OK = 0,
 ERROR = -1,
 FOUND = 1,



 E_READ = -1,
 E_WRITE = -2,
 E_INIT_CARD = -3,
 E_BOOT_SIGN = -4,
 E_BOOT_REC = -5,
 E_FILE_SYS_INFO = -6,
 E_DEVICE_SIZE = -7,
 E_FAT_TYPE = -8,



 E_LAST_ENTRY = -10,
 E_FREE_ENTRY = -11,
 E_CLUST_NUM = -12,
 E_NO_SWAP_SPACE = -13,
 E_NO_SPACE = -14,



 E_DIR_NAME = -20,
 E_ISNT_DIR = -21,
 E_DIR_EXISTS = -22,
 E_DIR_NOTFOUND = -23,
 E_DIR_NOTEMPTY = -24,



 E_FILE_NAME = -30,
 E_ISNT_FILE = -31,
 E_FILE_EXISTS = -32,
 E_FILE_NOTFOUND = -33,
 E_FILE_NOTEMPTY = -34,
 E_MAX_FILES = -35,
 E_FILE_NOTOPENED = -36,
 E_FILE_EOF = -37,
 E_FILE_READ = -38,
 E_FILE_WRITE = -39,
 E_FILE_HANDLE = -40,
 E_FILE_READ_ONLY = -41,
 E_FILE_OPENED = -42,



 E_TIME_YEAR = -50,
 E_TIME_MONTH = -51,
 E_TIME_DAY = -52,
 E_TIME_HOUR = -53,
 E_TIME_MINUTE = -54,
 E_TIME_SECOND = -55;



typedef struct
{
 uint8 State[1];
 uint8 __1[3];
 uint8 Type[1];
 uint8 __2[3];
 uint8 Boot[4];
 uint8 Size[4];
}
FAT32_PART;



typedef struct
{
 uint8 __1[446];
 FAT32_PART Part[4];
 uint8 BootSign[2];
}
FAT32_MBR;



typedef struct
{
 uint8 JmpCode[3];
 uint8 __1[8];
 uint8 BytesPSect[2];
 uint8 SectsPClust[1];
 uint8 Reserved[2];
 uint8 FATCopies[1];
 uint8 __2[4];
 uint8 MediaDesc[1];
 uint8 __3[10];
 uint8 Sects[4];
 uint8 SectsPFAT[4];
 uint8 Flags[2];
 uint8 __4[2];
 uint8 RootClust[4];
 uint8 FSISect[2];
 uint8 BootBackup[2];
 uint8 __5[14];
 uint8 ExtSign[1];
 uint8 __6[4];
 uint8 VolName[11];
 uint8 FATName[8];
 uint8 __7[420];
 uint8 BootSign[2];
}
FAT32_BR;



typedef struct
{
 uint8 LeadSig[4];
 uint8 __1[480];
 uint8 StrucSig[4];
 uint8 FreeCount[4];
 uint8 NextFree[4];
 uint8 __2[14];
 uint8 TrailSig[2];
}
FAT32_FSI;


typedef struct
{
 uint8 Entry[4];
}
FAT32_FATENT;



typedef struct
{
 uint8 NameExt[11];
 uint8 Attrib[1];
 uint8 __1[2];
 uint8 CTime[2];
 uint8 CDate[2];
 uint8 ATime[2];
 uint8 HiClust[2];
 uint8 MTime[2];
 uint8 MDate[2];
 uint8 LoClust[2];
 uint8 Size[4];
}
FAT32_DIRENT;



typedef uint32 __CLUSTER;
typedef uint32 __SECTOR;
typedef uint32 __ENTRY;

typedef int8 __HANDLE;



typedef struct
{
 uint16 Year;
 uint8 Month;
 uint8 Day;
 uint8 Hour;
 uint8 Minute;
 uint8 Second;
}
__TIME;



typedef struct
{
 uint8 State;
 uint8 Type;
 __SECTOR Boot;
 uint32 Size;
}
__PART;



typedef struct
{
 __PART Part[1];
 uint16 BytesPSect;
 uint8 SectsPClust;
 uint16 Reserved;
 uint8 FATCopies;
 uint32 SectsPFAT;
 uint16 Flags;
 __SECTOR FAT;
 __CLUSTER Root;
 __SECTOR Data;
 __SECTOR FSI;
 uint32 ClFreeCount;
 __CLUSTER ClNextFree;
}
__INFO;


typedef struct
{
 char NameExt[13];
 uint8 Attrib;

 uint32 Size;
 __CLUSTER _1stClust;

 __CLUSTER EntryClust;
 __ENTRY Entry;
}
__DIR;


typedef struct
{
 __CLUSTER _1stClust;
 __CLUSTER CurrClust;

 __CLUSTER EntryClust;
 __ENTRY Entry;

 uint32 Cursor;
 uint32 Length;

 uint8 Mode;
 uint8 Attr;
}
__FILE;
#line 332 "c:/c4w/mikroelektronika/mikroc pro for arm/packages/fat32 library/uses/__lib_fat32.h"
typedef struct
{
 __SECTOR fSectNum;
 char fSect[SECTOR_SIZE];
}
__RAW_SECTOR;


extern const char CRLF_F32[];
extern const uint8 FAT32_MAX_FILES;
extern const uint8 f32_fsi_template[SECTOR_SIZE];
extern const uint8 f32_br_template[SECTOR_SIZE];
extern __FILE fat32_fdesc[];
extern __RAW_SECTOR f32_sector;


extern int8 FAT32_Dev_Init (void);
extern int8 FAT32_Dev_Read_Sector (__SECTOR sc, char* buf);
extern int8 FAT32_Dev_Write_Sector (__SECTOR sc, char* buf);
extern int8 FAT32_Dev_Multi_Read_Stop();
extern int8 FAT32_Dev_Multi_Read_Sector(char* buf);
extern int8 FAT32_Dev_Multi_Read_Start(__SECTOR sc);
extern int8 FAT32_Put_Char (char ch);


int8 FAT32_Init (void);
int8 FAT32_Format (char *devLabel);
int8 FAT32_ScanDisk (uint32 *totClust, uint32 *freeClust, uint32 *badClust);
int8 FAT32_GetFreeSpace(uint32 *freeClusts, uint16 *bytesPerClust);

int8 FAT32_ChangeDir (char *dname);
int8 FAT32_MakeDir (char *dname);
int8 FAT32_Dir (void);
int8 FAT32_FindFirst (__DIR *pDE);
int8 FAT32_FindNext (__DIR *pDE);
int8 FAT32_Delete (char *fn);
int8 FAT32_DeleteRec (char *fn);
int8 FAT32_Exists (char *name);
int8 FAT32_Rename (char *oldName, char *newName);
int8 FAT32_Open (char *fn, uint8 mode);
int8 FAT32_Eof (__HANDLE fHandle);
int8 FAT32_Read (__HANDLE fHandle, char* rdBuf, uint16 len);
int8 FAT32_Write (__HANDLE fHandle, char* wrBuf, uint16 len);
int8 FAT32_Seek (__HANDLE fHandle, uint32 pos);
int8 FAT32_Tell (__HANDLE fHandle, uint32 *pPos);
int8 FAT32_Close (__HANDLE fHandle);
int8 FAT32_Size (char *fname, uint32 *pSize);
int8 FAT32_GetFileHandle(char *fname, __HANDLE *handle);

int8 FAT32_SetTime (__TIME *pTM);
int8 FAT32_IncTime (uint32 Sec);

int8 FAT32_GetCTime (char *fname, __TIME *pTM);
int8 FAT32_GetMTime (char *fname, __TIME *pTM);

int8 FAT32_SetAttr (char *fname, uint8 attr);
int8 FAT32_GetAttr (char *fname, uint8* attr);

int8 FAT32_GetError (void);

int8 FAT32_MakeSwap (char *name, __SECTOR nSc, __CLUSTER *pCl);

int8 FAT32_Dev_SectorCount(uint32 *scCnt);
#line 1 "c:/projects/webserver/__time.h"
#line 27 "c:/projects/webserver/__time.h"
typedef struct
 {
 unsigned char ss ;
 unsigned char mn ;
 unsigned char hh ;
 unsigned char md ;
 unsigned char wd ;
 unsigned char mo ;
 unsigned int yy ;
 } TimeStruct ;
#line 41 "c:/projects/webserver/__time.h"
extern long Time_jd1970 ;
#line 46 "c:/projects/webserver/__time.h"
long Time_dateToEpoch(TimeStruct *ts) ;
long Time_dateDiff(TimeStruct *t1, TimeStruct *t2);
void Time_epochToDate(long e, TimeStruct *ts) ;
#line 111 "C:/Projects/WebServer/websvr.c"
typedef enum
{
 SM_HTTP_IDLE = 0,
 SM_HTTP_GET_REQUEST,
 SM_HTTP_PARSE_REQUEST,
 SM_HTTP_FIND_FILE,
 SM_HTTP_FILE_NOT_FOUND,
 SM_HTTP_PARSE_HEADERS,
 SM_HTTP_AUTHENTICATE,
 SM_HTTP_PROCESS_GET,
 SM_HTTP_PROCESS_POST,
 SM_HTTP_PROCESS_REQUEST,
 SM_HTTP_SERVE_HEADERS,
 SM_HTTP_SERVE_COOKIES,
 SM_HTTP_OPEN_FILE,
 SM_HTTP_SERVE_BODY,
 SM_HTTP_SERVE_BODY2,
 SM_HTTP_SEND_FROM_CALLBACK,
 SM_HTTP_WAIT_TILL_DONE,
 SM_HTTP_DISCONNECT,

 SM_HTTP_SVR_SEND_REQUEST,
 SM_HTTP_SVR_GET_RESPONSE,
 SM_HTTP_SVR_PARSE_RESPONSE,
 SM_HTTP_SVR_OPEN_FILE,
 SM_HTTP_SVR_GET_DATA,
 SM_HTTP_SVR_DOWNLOAD_COMPLETE,
 SM_HTTP_SVR_DISCONNECT

} SM_SOCKET_SM;


typedef enum
{
 HTTP_TXT = 0,
 HTTP_HTM,
 HTTP_HTML,
 HTTP_CGI,
 HTTP_XML,
 HTTP_CSS,
 HTTP_GIF,
 HTTP_PNG,
 HTTP_JPG,
 HTTP_JAVA,
 HTTP_WAV,
 HTTP_UNKNOWN
} HTTP_FILE_TYPE;
#line 163 "C:/Projects/WebServer/websvr.c"
typedef enum
{
 CONNECTION_KEEP_ALIVE = 0,
 CONNECTION_CLOSE

} HTTP_connection_type;
#line 174 "C:/Projects/WebServer/websvr.c"
typedef enum
{
 ENCODING_TEXT = 0,
 ENCODING_CHUNKED,
 ENCODING_ZIP

} HTTP_transfer_encoding;
#line 188 "C:/Projects/WebServer/websvr.c"
typedef struct
{
 uint32_t epoch;
 uint8_t serverFlags;
 uint8_t serverStratum;
 int8_t serverPrecision;

} SNTP_Response_t;
#line 202 "C:/Projects/WebServer/websvr.c"
struct
{

  _Bool  request_send_flag;

  SOCKET_Intern_Dsc * eth_socket_download;

 uint32_t file_length;

 uint32_t capture_length;

 uint16_t transmit_size;

 uint32_t position;

 uint16_t remaining;

 __HANDLE swap_handle;
 __HANDLE download_handle;
 __SECTOR swap_sector;

} server_request;


typedef struct
{

 char page_name[13];

 char page_size_str[12];

 HTTP_FILE_TYPE page_type;

  _Bool  static_page_flag;

 struct
 {
 const char* const start_ptr;
 const char* current_ptr;
 const char* const end_ptr;

 } static_page;

 struct
 {
 char* const start_ptr;
 char* current_ptr;
 char* end_ptr;
 void ( *page_update )( void );

 } dynamic_page;

} webpage_t;
#line 264 "C:/Projects/WebServer/websvr.c"
typedef struct
{

  SOCKET_Intern_Dsc * eth_socket;

 SM_SOCKET_SM socketSM;

 HTTP_connection_type connect_type;

 HTTP_transfer_encoding encoding_type;

 char buffer_large[ 512 ];

 uint16_t buffer_position;

 char file_name[ 13 ];

 volatile uint8_t alive_time;

 webpage_t* webpage;

} socket_t;
#line 292 "C:/Projects/WebServer/websvr.c"
static const code char* http_file_extensions[HTTP_UNKNOWN+1] =
{
 "txt",
 "htm",
 "html",
 "cgi",
 "xml",
 "css",
 "gif",
 "png",
 "jpg",
 "js",
 "wav",
 "\0\0\0"
};




static const code char* http_content_types[HTTP_UNKNOWN+1] =
{
 "text/plain\n\n",
 "text/html\n\n",
 "text/html\n\n",
 "text/html\n\n",
 "text/xml\n\n",
 "text/css\n\n",
 "image/gif\n\n",
 "image/png\n\n",
 "image/jpeg\n\n",
 "application/x-javascript\n\n",
 "audio/x-wave\n\n",
 ""
};

static const code char* http_response_not_found = "HTTP/1.1 404 Not found\n\n";
static const code char* http_response_OK = "HTTP/1.1 200 OK";
static const code char* http_response_OK_old = "HTTP/1.0 200 OK";

static const code char* http_response_header =
 "HTTP/1.1 200 OK\r\nServer: Alphaloewe/1.0\r\nConnection: keep-alive\r\nDate: ";
static const code char* http_response_length = "\r\nContent-Length: ";
static const code char* http_response_type = "\r\nContent-Type: ";

static const code char* http_request_host = " HTTP/1.1\r\nHost: ";
static const code char* http_request_end = "\r\nConnection: keep-alive\r\nAccept: */*\r\n\r\n";
#line 343 "C:/Projects/WebServer/websvr.c"
static char GMT_string[30] = "Tue, 15 Nov 1994 08:12:31 GMT";
static const code char* days_in_week[] = {"Mon","Tue","Wed","Thu","Fri","Sat","Sun"};
static const code char* months_in_year[] = {"Nul","Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"};
static volatile uint32_t ntp_epoch_time = 0;


static webpage_t pages[ 17 ];
static int8_t page_number = 0;

static uint16_t http_port = 0;
static char get_post_buffer[ 512 ];


static  _Bool  irqModeEnable =  0 ;
static volatile  _Bool  packet_flag =  0 ;


static key_value_t form_fields[ 20 ];

static char downloaded_filename[ 13 ];


static uint8_t stackTop = -1;
static socket_t sockets[ 7 ], *socketStack[ 7 ], *socketInUse[ 7 ];


void ( *form_received )( key_value_t* values );
void ( *file_download )( char* fileName );
void ( *ntp_received )( uint32_t time );
#line 377 "C:/Projects/WebServer/websvr.c"
static void strcpy_const( char* destination, const char* source );
static void strcat_const( char* destination, const char* source );
static int strncmp_const( char* str1, const char* str2, int num );

static void update_GMT_str( char* gmt_str );
#line 390 "C:/Projects/WebServer/websvr.c"
static int stack_push ( socket_t** stack, socket_t* socket );
static socket_t* stack_pop ( socket_t** stack );

static uint8_t get_chunked_size ( uint16_t* new_size );
#line 399 "C:/Projects/WebServer/websvr.c"
static socket_t* init_new_socket(  SOCKET_Intern_Dsc * eth_socket );

static void get_client_request ( socket_t* const socket );

static void parse_client_request( socket_t* const socket );

static void process_get_request ( socket_t* const socket );

static void find_requested_file ( socket_t* const socket );

static void serve_headers ( socket_t* const socket );

static void serve_body ( socket_t* const socket );



static void close_socket ( socket_t* const socket );
#line 420 "C:/Projects/WebServer/websvr.c"
static void server_send_request ( socket_t* const socket );

static void get_server_response ( socket_t* const socket );

static void parse_server_response( socket_t* const socket );

static void open_server_file ( socket_t* const socket );

static void get_server_data ( socket_t* const socket );

static void close_server_socket ( socket_t* const socket );
#line 465 "C:/Projects/WebServer/websvr.c"
static void strcpy_const( char* destination, const char* source )
{
 while( *destination++ = *source++ );

 *destination = '\0';
}
#line 477 "C:/Projects/WebServer/websvr.c"
static void strcat_const( char* destination, const char* source )
{
 while( *destination != '\0' )
 {
 destination++;
 }

 strcpy_const( destination, source );
}
#line 492 "C:/Projects/WebServer/websvr.c"
static int strncmp_const( char* str1, const char* str2, int num )
{
 while( num-- != 0 )
 {
 if( *str1++ != *str2++ )
 {
 return 1;
 }

 }

 return 0;
}
#line 521 "C:/Projects/WebServer/websvr.c"
static void update_GMT_str( char* gmt_str )
{

 TimeStruct ts1;

 Time_epochToDate( ntp_epoch_time, &ts1 );

 gmt_str[0] = days_in_week[ts1.wd][0];
 gmt_str[1] = days_in_week[ts1.wd][1];
 gmt_str[2] = days_in_week[ts1.wd][2];
 gmt_str[3] = ',';
 gmt_str[4] = ' ';
 gmt_str[5] = ( ts1.md / 10 ) + 48;
 gmt_str[6] = ( ts1.md % 10 ) + 48;
 gmt_str[7] = ' ';
 gmt_str[8] = months_in_year[ts1.mo][0];
 gmt_str[9] = months_in_year[ts1.mo][1];
 gmt_str[10] = months_in_year[ts1.mo][2];
 gmt_str[11] = ' ';
 gmt_str[12] = '2';
 gmt_str[13] = '0';
 gmt_str[14] = ( ( ts1.yy - 2000 ) / 10 ) + 48;
 gmt_str[15] = ( ( ts1.yy - 2000 ) % 10 ) + 48;
 gmt_str[16] = ' ';
 gmt_str[17] = ( ts1.hh / 10 ) + 48;
 gmt_str[18] = ( ts1.hh % 10 ) + 48;
 gmt_str[19] = ':';
 gmt_str[20] = ( ts1.mn / 10 ) + 48;
 gmt_str[21] = ( ts1.mn % 10 ) + 48;
 gmt_str[22] = ':';
 gmt_str[23] = ( ts1.ss / 10 ) + 48;
 gmt_str[24] = ( ts1.ss % 10 ) + 48;
 gmt_str[25] = ' ';
 gmt_str[26] = 'G';
 gmt_str[27] = 'M';
 gmt_str[28] = 'T';
 gmt_str[29] = '\0';
}
#line 567 "C:/Projects/WebServer/websvr.c"
static int stack_push( socket_t** stack, socket_t* socket )
{
 int socket_index;

 if( stackTop == (  7 -1 ) )
 {
 return -1;
 }

 else
 {

 memset( socket->buffer_large, 0,  512  );
 memset( socket->file_name, 0,  13  );
 socket->buffer_position = 0;
 socket->socketSM = SM_HTTP_IDLE;
 socket->webpage =  ((void *)0) ;
 socket->eth_socket =  ((void *)0) ;

 stack[++stackTop] = socket;

 for( socket_index = 0; socket_index <  7 ; socket_index++ )
 {
 if( socketInUse[socket_index] == socket )
 {
 socketInUse[socket_index] =  ((void *)0) ;
 break;
 }
 }

 return 0;
 }

}
#line 606 "C:/Projects/WebServer/websvr.c"
static socket_t* stack_pop( socket_t** stack )
{
 int i;

 if ( stackTop == -1 )
 {
 return  ((void *)0) ;
 }

 else
 {
 socket_t* temp = stack[stackTop];
 stack[stackTop--] = 0;

 for( i = 0; i <  7 ; i++ )
 {
 if( socketInUse[i] ==  ((void *)0)  )
 {
 socketInUse[i] = temp;
 break;
 }
 }

 return temp;
 }
}
#line 640 "C:/Projects/WebServer/websvr.c"
static socket_t* init_new_socket(  SOCKET_Intern_Dsc * eth_socket )
{
 int socketCount;
 socket_t* newSocket =  ((void *)0) ;

 for( socketCount = 0; socketCount <  7 ; socketCount++ )
 {
 if( socketInUse[socketCount] !=  ((void *)0)  )
 {
 if( socketInUse[socketCount]->eth_socket == eth_socket )
 {
 return socketInUse[socketCount];
 }
 }
 }

 newSocket = stack_pop( socketStack );

 newSocket->eth_socket = eth_socket;
 newSocket->socketSM = SM_HTTP_GET_REQUEST;

 return newSocket;
}
#line 678 "C:/Projects/WebServer/websvr.c"
static int get_chunked_size( uint16_t* new_size )
{

 char length_str[5] = {0};
 char* p_length = length_str;
 int bytes_read = 0;
 char tmp_buffer;
  _Bool  terminate =  0 ;

 while( terminate !=  1  && bytes_read++ < 8 )
 {
 tmp_buffer =  Net_Ethernet_Intern_getByte ();

 switch( tmp_buffer )
 {
 case  0x0D :
 break;

 case  0x0A :
 if( bytes_read > 2 )
 {
 terminate =  1 ;
 *new_size = xtoi( length_str );
 }

 break;

 default:
 *p_length++ = tmp_buffer;
 }
 }

 return bytes_read;
}
#line 724 "C:/Projects/WebServer/websvr.c"
static void get_client_request( socket_t* const socket )
{
 uint16_t len = socket->eth_socket->dataLength;

 if( len == 0 )
 {
 close_socket( socket );
 }

 else
 {
 char window_buffer[ 512 ];

 if(  512  < ( len + socket->buffer_position ) )
 {
  Net_Ethernet_Intern_getBytes ( window_buffer, 0xFFFF, len );
 strcat( socket->buffer_large, window_buffer );
 socket->buffer_position += len;

 if( len <  512  )
 {
 socket->buffer_position = 0;
 socket->socketSM = SM_HTTP_PARSE_REQUEST;
 }
 }
 else
 {
 while( socket->buffer_position <  512  )
 {
 socket->buffer_large[socket->buffer_position++] =  Net_Ethernet_Intern_getByte ();
 }
 socket->buffer_position = 0;
 socket->socketSM = SM_HTTP_PARSE_REQUEST;
 }
 }
}
#line 769 "C:/Projects/WebServer/websvr.c"
static void parse_client_request( socket_t* const socket )
{
 char* p_parse;
 char* const p_buffer = socket->buffer_large;


 socket->socketSM = SM_HTTP_DISCONNECT;


 p_parse = strtok( p_buffer, "\n" );

 while( p_parse !=  ((void *)0)  )
 {
 if( strncmp( p_parse, "GET ", 4 ) == 0 )
 {
 socket->socketSM = SM_HTTP_PROCESS_GET;
 strcpy( get_post_buffer, p_parse );
 }

 else if( strncmp( p_parse, "POST ", 4 ) == 0 )
 {
 socket->socketSM = SM_HTTP_PROCESS_POST;
 strcpy( get_post_buffer, p_parse );
 }

 else if( strncmp( p_parse, "Conne", 4 ) == 0 )
 {
 char* p_connect;
 p_connect = strchr( p_parse, ' ' );
 p_connect++;

 if( strncmp( p_connect, "keep-alive", 2 ) == 0 )
 {
 socket->connect_type = CONNECTION_KEEP_ALIVE;
 }

 else if( strncmp( p_connect, "close", 2 ) == 0 )
 {
 socket->connect_type = CONNECTION_CLOSE;
 }
 }
#line 822 "C:/Projects/WebServer/websvr.c"
 p_parse = strtok(  ((void *)0) , "\n" );
 }
}
#line 834 "C:/Projects/WebServer/websvr.c"
static void process_get_request( socket_t* const socket )
{
 char* p_buffer = get_post_buffer;
 char* p_parser;


 while( *p_buffer++ != ' ' );


 if( strchr( p_buffer, '?' ) ==  ((void *)0)  )
 {

 if( strncmp( p_buffer, "/ ", 2 ) ==  ((void *)0)  )
 {
 strcpy( socket->file_name, "index.htm" );
 socket->socketSM = SM_HTTP_FIND_FILE;
 }

 else
 {
 char* tmp_parser;
 int i = 0, j = 0;

 p_parser = strchr( p_buffer, ' ' );

 *p_parser = '\0';

 p_parser = strchr( p_buffer, '/' );

 while( p_parser !=  ((void *)0)  )
 {
 p_parser++;
 tmp_parser = p_parser;
 p_parser = strchr( p_parser, '/' );
 }

 while( ( *tmp_parser != '.' ) && ( i < 8 ) )
 {
 socket->file_name[i++] = *tmp_parser++;
 }

 tmp_parser++;
 socket->file_name[i++] = '.';

 while( ( *tmp_parser != '\0' && j < 3 ) )
 {
 socket->file_name[i++] = *tmp_parser++;
 j++;
 }

 socket->file_name[i] = '\0';

 socket->socketSM = SM_HTTP_FIND_FILE;
 }
 }

 else
 {
 int i = 0, j = 0;

 p_buffer++;

 while( *p_buffer != '.' )
 {
 socket->file_name[i++] = *p_buffer++;
 }

 p_buffer++;
 socket->file_name[i++] = '.';

 while( ( *p_buffer != '?' && j < 3 ) )
 {
 socket->file_name[i++] = *p_buffer++;
 j++;
 }



 socket->file_name[i] = '\0';
 p_buffer++;

 i = 0;
 j = 0;

 p_parser = strchr( p_buffer, ' ' );
 *p_parser = '\0';
 p_parser = strtok( p_buffer, "&" );

 while( p_parser !=  ((void *)0)  && i <  20  )
 {
 j = 0;

 while( *p_parser != '=' && j <  25  )
 {
 form_fields[i].key[j++] = *p_parser++;
 }

 form_fields[i].key[j] = '\0';

 p_parser++;
 j = 0;

 while( *p_parser != '\0' && j <  25  )
 {
 form_fields[i].value[j++] = *p_parser++;
 }

 form_fields[i].value[j] = '\0';

 i++;

 form_fields[i].key[0] = '\0';
 form_fields[i].value[0] = '\0';

 p_parser = strtok(  ((void *)0) , "&" );
 }

 socket->socketSM = SM_HTTP_FIND_FILE;

 form_received( form_fields );
 }
}
#line 967 "C:/Projects/WebServer/websvr.c"
static void process_post_request( socket_t* const socket )
{


}
#line 983 "C:/Projects/WebServer/websvr.c"
static void find_requested_file( socket_t* const socket )
{
 int page_index;

 socket->socketSM = SM_HTTP_FILE_NOT_FOUND;

 for( page_index = 0; page_index < page_number; page_index++ )
 {

 if( strcmp( socket->file_name, pages[page_index].page_name ) == 0 )
 {

 socket->webpage = &pages[page_index];

 socket->socketSM = SM_HTTP_SERVE_HEADERS;

 if( socket->webpage->static_page_flag ==  0  )
 {
 char txt_buffer[12];
 uint32_t p_size;

 pages[page_index].dynamic_page.page_update();

 p_size = strlen( pages[page_index].dynamic_page.start_ptr );

 LongToStr( p_size, txt_buffer );
 strcpy( pages[page_index].page_size_str, Ltrim( txt_buffer ) );

 pages[page_index].dynamic_page.end_ptr = pages[page_index].dynamic_page.start_ptr + p_size;

 }

 break;
 }
 }
}
#line 1030 "C:/Projects/WebServer/websvr.c"
static void serve_headers( socket_t* const socket )
{

  Net_Ethernet_Intern_putConstStringTCP ( http_response_header, socket->eth_socket );

  Net_Ethernet_Intern_putStringTCP  ( GMT_string, socket->eth_socket );

  Net_Ethernet_Intern_putConstStringTCP ( http_response_length, socket->eth_socket );
  Net_Ethernet_Intern_putStringTCP  ( socket->webpage->page_size_str, socket->eth_socket );

  Net_Ethernet_Intern_putConstStringTCP ( http_response_type, socket->eth_socket );
  Net_Ethernet_Intern_putConstStringTCP ( http_content_types[socket->webpage->page_type], socket->eth_socket );

 socket->socketSM = SM_HTTP_SERVE_BODY;
}
#line 1054 "C:/Projects/WebServer/websvr.c"
static void serve_body( socket_t* const socket )
{
  _Bool  done_flag =  0 ;
 uint16_t remaining_bytes;


 if( socket->webpage->static_page_flag ==  1  )
 {

 remaining_bytes = ( socket->webpage->static_page.end_ptr - socket->webpage->static_page.current_ptr );

 socket->webpage->static_page.current_ptr +=  Net_Ethernet_Intern_putConstBytesTCP ( socket->webpage->static_page.current_ptr,
 remaining_bytes,
 socket->eth_socket );


 if( socket->webpage->static_page.current_ptr == socket->webpage->static_page.end_ptr )
 {
 done_flag =  1 ;
 socket->webpage->static_page.current_ptr = socket->webpage->static_page.start_ptr;
 }
 }


 else
 {

 remaining_bytes = ( socket->webpage->dynamic_page.end_ptr - socket->webpage->dynamic_page.current_ptr );

 socket->webpage->dynamic_page.current_ptr +=  Net_Ethernet_Intern_putBytesTCP ( socket->webpage->dynamic_page.current_ptr,
 remaining_bytes,
 socket->eth_socket );


 if( socket->webpage->dynamic_page.current_ptr == socket->webpage->dynamic_page.end_ptr )
 {
 done_flag =  1 ;
 socket->webpage->dynamic_page.current_ptr = socket->webpage->dynamic_page.start_ptr;
 }
 }


 if( done_flag ==  1  )
 {
 switch( socket->connect_type )
 {
 case CONNECTION_CLOSE:
 socket->socketSM = SM_HTTP_WAIT_TILL_DONE;
 break;

 case CONNECTION_KEEP_ALIVE:
 memset( socket->buffer_large, 0,  512  );
 memset( socket->file_name, 0,  13  );
 socket->webpage =  ((void *)0) ;
 socket->socketSM = SM_HTTP_GET_REQUEST;
 break;
 }
 }
}
#line 1122 "C:/Projects/WebServer/websvr.c"
static void close_socket( socket_t* const socket )
{

 if( socket->eth_socket == server_request.eth_socket_download )
 {
 close_server_socket( socket );
 }

 else
 {
 if(  Net_Ethernet_Intern_disconnectTCP ( socket->eth_socket ) == 1 )
 {

 if( socket->webpage !=  ((void *)0)  )
 {

 if( socket->webpage->static_page_flag ==  1  )
 {

 socket->webpage->static_page.current_ptr = socket->webpage->static_page.start_ptr;
 }

 else
 {

 socket->webpage->dynamic_page.current_ptr = socket->webpage->dynamic_page.start_ptr;
 }
 }


 stack_push( socketStack, socket );
 }

 else
 {
  UART1_Write_Text("Could not close socket\r\n") ;
 }
 }
}
#line 1175 "C:/Projects/WebServer/websvr.c"
static void server_send_request( socket_t* const socket )
{

  Net_Ethernet_Intern_putBytesTCP ( socket->buffer_large, server_request.transmit_size, socket->eth_socket );

 socket->socketSM = SM_HTTP_SVR_GET_RESPONSE;
}
#line 1193 "C:/Projects/WebServer/websvr.c"
static void get_server_response( socket_t* const socket )
{
 uint16_t len = socket->eth_socket->dataLength;
 uint8_t termination = 0;
 char buffer;

 while( len-- > 0 )
 {
 buffer =  Net_Ethernet_Intern_getByte ();

 switch( buffer )
 {
 case  0x0D :
 break;

 case  0x0A :
 socket->buffer_large[server_request.position++] = buffer;
 termination++;


 if( termination == 2 )
 {
 server_request.remaining = len;
 socket->buffer_large[server_request.position] = '\0';
 socket->socketSM = SM_HTTP_SVR_PARSE_RESPONSE;
 return;
 }

 break;

 default:
 socket->buffer_large[server_request.position++] = buffer;
 termination = 0;
 }

 if( server_request.position ==  512  )
 {
 server_request.remaining = len;
 socket->buffer_large[server_request.position] = '\0';
 socket->socketSM = SM_HTTP_SVR_PARSE_RESPONSE;
 return;
 }
 }
}
#line 1248 "C:/Projects/WebServer/websvr.c"
static void parse_server_response( socket_t* const socket )
{
 char* p_parser;
 char* const p_buffer = socket->buffer_large;

 p_parser = strtok( p_buffer, "\n" );

 if( p_parser ==  ((void *)0)  )
 {
  UART1_Write_Text("Not valid header\r\n") ;
 socket->socketSM = SM_HTTP_SVR_DISCONNECT;
 return;
 }

 else if( ( strncmp_const( p_parser, http_response_OK , 13 ) == 0 )
 || ( strncmp_const( p_parser, http_response_OK_old , 13 ) == 0 ) )
 {
 p_parser = strtok(  ((void *)0) , "\n" );

 while( p_parser !=  ((void *)0)  )
 {



 if( p_parser[0] == 'C' )
 {
 switch( p_parser[8] )
 {
 case 'D':
 {
 int i = 0;
 int j = 0;
 char* ptr;

 ptr = strchr( p_parser, '"' );
 ptr++;

 while( *( ptr ) != '.' && i < 8 )
 {
 socket->file_name[i++] = *ptr++;
 }

 if( *ptr != '.' )
 {
 while( *( ++ptr ) != '.' );
 }

 socket->file_name[i++] = *ptr++;

 while( *( ptr ) != '"' && j < 3 )
 {
 socket->file_name[i++] = *( ptr++ );
 j++;
 }

 socket->file_name[i] = '\0';
 strcpy( downloaded_filename, socket->file_name );

 break;
 }

 case 'L':
 server_request.file_length = atol( strchr( p_parser, ' ' ) );

 socket->connect_type = CONNECTION_KEEP_ALIVE;

 if( server_request.file_length == 0 )
 {
 socket->socketSM = SM_HTTP_SVR_DISCONNECT;
 return;
 }

 break;

 case 'T':

 break;

 case 'o':
 {
 char* p_connect;
 p_connect = strchr( p_parser, ' ' );

 p_connect++;

 if( strncmp( p_connect, "keep-alive", 6 ) == 0 )
 {
 socket->connect_type = CONNECTION_KEEP_ALIVE;
 }

 else if( strncmp( p_connect, "close", 5 ) == 0 )
 {
 socket->connect_type = CONNECTION_CLOSE;
 }

 break;
 }
 }
 }

 else if( p_parser[0] == 'T' )
 {
 if( p_parser[9] == 'E' )
 {
 char* p_encode;
 p_encode = strchr( p_parser, ' ' );
 p_encode++;

 if( strncmp( p_encode, "chunked", 3 ) == 0 )
 {
 server_request.position = 0;
 socket->encoding_type = ENCODING_CHUNKED;
 }
 }
 }

 p_parser = strtok(  ((void *)0) , "\n" );
 }

 socket->socketSM = SM_HTTP_SVR_OPEN_FILE;
 }

 else
 {
  UART1_Write_Text("Not a valid response\r\n") ;
 socket->socketSM = SM_HTTP_SVR_DISCONNECT;
 }
}
#line 1387 "C:/Projects/WebServer/websvr.c"
static void open_server_file( socket_t* const socket )
{

 if( FAT32_Exists(  "download.bin"  ) == 1 )
 {
 FAT32_Delete(  "download.bin"  );
 }

 if( FAT32_MakeSwap(  "download.bin" , 1000, &server_request.swap_sector ) == 0 )
 {
 server_request.swap_handle = FAT32_Open(  "download.bin" , FILE_WRITE );

 if( server_request.swap_handle < 0 )
 {
  UART1_Write_Text("Could not open swapfile\r\n") ;
 socket->socketSM = SM_HTTP_SVR_DISCONNECT;
 }

 else
 {

 uint16_t len = server_request.remaining;
 char buffer[ 512 ] = {0};


 if( socket->encoding_type == ENCODING_CHUNKED )
 {
 int i;
 char* p_buffer = buffer;

 for( i = 0; i < len; i++ )
 {
 if( server_request.position == 0 )
 {
 i += get_chunked_size( &server_request.position );
 }

 *p_buffer++ =  Net_Ethernet_Intern_getByte ();
 server_request.position--;
 }

 len = strlen( buffer );
 }

 else
 {

  Net_Ethernet_Intern_getBytes ( buffer, 0xFFFF, len );
 }


 if( FAT32_WriteSwap( server_request.swap_handle, buffer, len ) != 0 )
 {
  UART1_Write_Text("Error in writting to swap\r\n") ;
 socket->socketSM = SM_HTTP_SVR_DISCONNECT;
 }

 else
 {

 server_request.capture_length += len;
 socket->socketSM = SM_HTTP_SVR_GET_DATA;
 }
 }
 }

 else
 {
  UART1_Write_Text("Could not create swapfile\r\n") ;
 socket->socketSM = SM_HTTP_SVR_DISCONNECT;
 }
}
#line 1468 "C:/Projects/WebServer/websvr.c"
static void get_server_data( socket_t* const socket )
{
 char buffer[ 512 ] = {0};
 uint16_t len = socket->eth_socket->dataLength;
  _Bool  download_flag =  0 ;


 if( socket->encoding_type == ENCODING_CHUNKED )
 {
 int i;
 char* p_buffer = buffer;

 for( i = 0; i < len; i++ )
 {
 if( server_request.position == 0 )
 {
 i += get_chunked_size( &server_request.position );

 if( server_request.position == 0 )
 {
 download_flag =  1 ;
 break;
 }
 }

 *p_buffer++ =  Net_Ethernet_Intern_getByte ();
 server_request.position--;
 }

 len = strlen( buffer );
 }

 else
 {
  Net_Ethernet_Intern_getBytes ( buffer, 0xFFFF, len );
 }


 if( FAT32_WriteSwap( server_request.swap_handle, buffer, len ) != 0 )
 {
  UART1_Write_Text("Error in writting to swap\r\n") ;
 socket->socketSM = SM_HTTP_SVR_DISCONNECT;
 }

 else
 {
 server_request.capture_length += len;


 switch ( socket->connect_type )
 {
 case CONNECTION_KEEP_ALIVE:
 if( server_request.capture_length >= server_request.file_length )
 {
  UART1_Write_Text("\nKeep alive - Done!\r\n") ;
 socket->socketSM = SM_HTTP_SVR_DISCONNECT;
 }

 break;

 case CONNECTION_CLOSE:
 if( server_request.file_length == 0 )
 {
 if( download_flag ==  1  )
 {
  UART1_Write_Text("\nClose - DONE!\r\n") ;
 socket->socketSM = SM_HTTP_SVR_DISCONNECT;
 }
 }

 else
 {
 if( server_request.capture_length >= server_request.file_length )
 {
  UART1_Write_Text("\nClose: Length included - Done!\r\n") ;
 socket->socketSM = SM_HTTP_SVR_DISCONNECT;
 }
 }

 break;
 }
 }
}
#line 1560 "C:/Projects/WebServer/websvr.c"
static void close_server_socket( socket_t* const socket )
{
 if(  Net_Ethernet_Intern_disconnectTCP ( socket->eth_socket ) == 1 )
 {
  _Bool  file_ready =  0 ;


 if( FAT32_GetFileHandle(  "download.bin" , &server_request.swap_handle ) != -1 )
 {

 FAT32_Close( server_request.swap_handle );
 }


 if( server_request.capture_length > 0 )
 {
 if( FAT32_Exists(  "download.bin"  ) == 1 )
 {
 server_request.swap_handle = FAT32_Open(  "download.bin" , FILE_READ );

 if( FAT32_Exists( socket->file_name ) == 1 )
 {
 FAT32_Delete( socket->file_name );
 }

 server_request.download_handle = FAT32_Open( socket->file_name, FILE_WRITE );

 if( ( server_request.swap_handle < 0 ) || ( server_request.download_handle < 0 ) )
 {
 FAT32_Close( server_request.swap_handle );
 FAT32_Close( server_request.download_handle );
 FAT32_Delete(  "download.bin"  );
 }

 else
 {
 char txt_buf[50];

 char p_data_buffer[SECTOR_SIZE];
 uint16_t sectors = ( server_request.capture_length / SECTOR_SIZE );
 uint16_t remain = ( server_request.capture_length % SECTOR_SIZE );

 sprinti( txt_buf, "Position is still: %u\r\n", server_request.position );
  UART1_Write_Text(txt_buf) ;

 while( sectors-- != 0 )
 {
 FAT32_ReadSwap( server_request.swap_handle, p_data_buffer, SECTOR_SIZE );
 FAT32_Write ( server_request.download_handle, p_data_buffer, SECTOR_SIZE );
 }


 FAT32_ReadSwap( server_request.swap_handle, p_data_buffer, remain );
 FAT32_Write ( server_request.download_handle, p_data_buffer, remain );

 FAT32_Close ( server_request.swap_handle );
 FAT32_Close ( server_request.download_handle );

 FAT32_Delete(  "download.bin"  );

 strcpy( downloaded_filename, socket->file_name );

 file_ready =  1 ;
 }
 }
 }


 server_request.eth_socket_download =  ((void *)0) ;
 server_request.capture_length = 0;
 server_request.file_length = 0;
 server_request.position = 0;
 stack_push( socketStack, socket );

 if( file_ready ==  1  )
 {
 file_download( downloaded_filename );
 }
 }
}
#line 1652 "C:/Projects/WebServer/websvr.c"
void  Net_Ethernet_Intern_UserTCP (  SOCKET_Intern_Dsc * eth_socket )
{
 if( eth_socket->destPort == http_port )
 {
 socket_t* current_socket = init_new_socket( eth_socket );

 if( current_socket !=  ((void *)0)  )
 {

 current_socket->alive_time = 0;


 switch( current_socket->socketSM )
 {
 case SM_HTTP_GET_REQUEST:

 get_client_request( current_socket );

 if( current_socket->socketSM != SM_HTTP_PARSE_REQUEST )
 {
 break;
 }

 case SM_HTTP_PARSE_REQUEST:

 parse_client_request( current_socket );

 if( current_socket->socketSM != SM_HTTP_PROCESS_GET )
 {
 break;
 }

 case SM_HTTP_PROCESS_GET:

 process_get_request( current_socket );

 if( current_socket->socketSM != SM_HTTP_FIND_FILE )
 {
 break;
 }

 case SM_HTTP_FIND_FILE:

 find_requested_file( current_socket );


 if( current_socket->socketSM == SM_HTTP_FILE_NOT_FOUND )
 {
  Net_Ethernet_Intern_putConstStringTCP ( http_response_not_found, current_socket->eth_socket );

 if( current_socket->connect_type == CONNECTION_CLOSE )
 {
 current_socket->socketSM = SM_HTTP_DISCONNECT;
 }

 else
 {
 memset( current_socket->file_name, 0,  13  );
 memset( current_socket->buffer_large, 0,  512  );
 current_socket->socketSM = SM_HTTP_GET_REQUEST;
 }

 break;
 }

 case SM_HTTP_SERVE_HEADERS:

 serve_headers( current_socket );

 case SM_HTTP_SERVE_BODY:

 serve_body( current_socket );

 if( current_socket->socketSM != SM_HTTP_WAIT_TILL_DONE )
 {
 break;
 }

 case SM_HTTP_WAIT_TILL_DONE:


 if(  Net_Ethernet_Intern_bufferEmptyTCP ( current_socket->eth_socket ) != 1 )
 {
 break;
 }

 current_socket->socketSM = SM_HTTP_DISCONNECT;

 case SM_HTTP_DISCONNECT:

 close_socket( current_socket );
 break;
 }
 }
 }

 else if( eth_socket->destPort ==  10021  )
 {
 socket_t* current_socket = init_new_socket( eth_socket );


 current_socket->alive_time = 0;

 switch( current_socket->socketSM )
 {
 case SM_HTTP_SVR_SEND_REQUEST:

 server_send_request( current_socket );
 break;

 case SM_HTTP_SVR_GET_RESPONSE:

 get_server_response( current_socket );

 if( current_socket->socketSM != SM_HTTP_SVR_PARSE_RESPONSE )
 {
 break;
 }

 case SM_HTTP_SVR_PARSE_RESPONSE:

 parse_server_response( current_socket );

 if( current_socket->socketSM != SM_HTTP_SVR_OPEN_FILE )
 {
  UART1_Write_Text("Bad things happened\r\n") ;
 close_socket( current_socket );
 break;
 }

 case SM_HTTP_SVR_OPEN_FILE:

 open_server_file( current_socket );
 break;

 case SM_HTTP_SVR_GET_DATA:

 get_server_data( current_socket );

 if( current_socket->socketSM != SM_HTTP_SVR_DISCONNECT )
 {
 break;
 }

 case SM_HTTP_SVR_DISCONNECT:

 close_server_socket( current_socket );
 break;
 }
 }
}
#line 1812 "C:/Projects/WebServer/websvr.c"
unsigned int  Net_Ethernet_Intern_UserUDP (  UDP_Intern_Dsc * udpDsc )
{

 if( udpDsc->destPort ==  123  )
 {
 SNTP_Response_t tmResp;
 uint32_t tts = 0;
 int ntpCount;

 tmResp.serverFlags =  Net_Ethernet_Intern_getByte ();
 tmResp.serverStratum =  Net_Ethernet_Intern_getByte ();

  Net_Ethernet_Intern_getByte ();
 tmResp.serverPrecision =  Net_Ethernet_Intern_getByte ();


 for( ntpCount = 0 ; ntpCount < 36 ; ntpCount++ )
 {
  Net_Ethernet_Intern_getByte ();
 }


  ((char *)&tts)[3]  =  Net_Ethernet_Intern_getByte ();
  ((char *)&tts)[2]  =  Net_Ethernet_Intern_getByte ();
  ((char *)&tts)[1]  =  Net_Ethernet_Intern_getByte ();
  ((char *)&tts)[0]  =  Net_Ethernet_Intern_getByte ();


 tmResp.epoch = ( tts - 2208988800 );

 ntp_epoch_time = tmResp.epoch;

 update_GMT_str( GMT_string );

 ntp_received( ntp_epoch_time );

 return ( udpDsc->dataLength );
 }

 return 0;
}
#line 1860 "C:/Projects/WebServer/websvr.c"
int8_t webserver_request_NTP( char* const ntpSrv )
{
 char* p_remoteIP =  ((void *)0) ;
 int8_t tries = 5;

 do
 {
  UART1_Write_Text("Wait... Trying to resolve NTP server\r\n") ;
 p_remoteIP =  Net_Ethernet_Intern_dnsResolve ( ntpSrv, 5 );
 }
 while( ( p_remoteIP ==  ((void *)0)  ) && ( tries-- > 0 ) );

 if( tries > 0 )
 {
 uint8_t remoteIpAddr[4];
 uint8_t sntpPkt[48];

 memcpy( remoteIpAddr, p_remoteIP, 4 );

 sntpPkt[0] = 0b00011001;
 sntpPkt[1] = 0x00;
 sntpPkt[2] = 0x0a;
 sntpPkt[3] = 0xfa;

 sntpPkt[6] = 0x44 ;

 sntpPkt[9] = 0x10 ;






  Net_Ethernet_Intern_sendUDP ( remoteIpAddr,  123 ,  123 , sntpPkt, 48 );
 return 0;
 }

 else
 {
 UART1_Write_Text( "Could not resolve DNS address for Time\n" );
 return -1;
 }
}
#line 1915 "C:/Projects/WebServer/websvr.c"
int8_t webserver_request_file( char* const request, uint16_t port )
{

 if( server_request.eth_socket_download !=  ((void *)0)  )
 {
  UART1_Write_Text("Download in progress\r\n") ;
 return -1;
 }

 else
 {

 if( strncmp( request, "http://", 7 ) != 0 )
 {
  UART1_Write_Text("Not a http request\r\n") ;
 return -1;
 }

 else
 {
 char* p_remoteIP =  ((void *)0) ;
 char* p_request =  ((void *)0) ;
 int8_t tries = 5;
 int domainCount = 0;
 char domain[ 50 ];

 p_request = strstr( request, "//" );

 p_request += 2;

 while( *p_request != '/' && domainCount <  50  )
 {
 domain[domainCount] = *( p_request++ );
 domainCount++;
 }


 domain[domainCount] = '\0';


 do
 {
  UART1_Write_Text("Wait... Trying to resolve DNS\r\n") ;
 p_remoteIP =  Net_Ethernet_Intern_dnsResolve ( domain, 5 );
 }
 while( ( p_remoteIP ==  ((void *)0)  ) && ( tries-- > 0 ) );

 if( tries > 0 )
 {
 char remoteIPAddr[4] = {0};
 socket_t* client_socket;
 char* p_buffer;
 int i;

 client_socket = stack_pop( socketStack );

 p_buffer = client_socket->buffer_large;

 strcpy ( p_buffer, "GET " );
 strcat ( p_buffer, p_request );
 strcat_const( p_buffer, http_request_host );
 strcat ( p_buffer, domain );
 strcat_const( p_buffer, http_request_end );

 for( i = 0; request[i]; i++ )
 {
 if( request[i] == '/' )
 {
 if( request[i+1] )
 {
 p_request = &request[i+1];
 }
 }
 }

 if( strchr( p_request, '.' ) != 0 )
 {
 strcpy( client_socket->file_name, p_request );
 }

 tries = 5;
 memcpy( remoteIPAddr, p_remoteIP, 4 );

 server_request.transmit_size = strlen( p_buffer );
 client_socket->socketSM = SM_HTTP_SVR_SEND_REQUEST;
 server_request.request_send_flag =  1 ;

 while( (  Net_Ethernet_Intern_connectTCP ( remoteIPAddr, port,  10021 , &server_request.eth_socket_download ) != 1 )
 && ( tries-- > 0 ) ) ;

 if( tries > 0 )
 {
 client_socket->eth_socket = server_request.eth_socket_download;
 return 0;
 }

 else
 {
 close_socket( client_socket );
  UART1_Write_Text("Could not connect\r\n") ;
 return -1;
 }

 }

 else
 {
  UART1_Write_Text("Could not resolve DNS\r\n") ;
 return -1;
 }

 }

 }

}
#line 2036 "C:/Projects/WebServer/websvr.c"
void webserver_time_update()
{
 int socketCount;

 for( socketCount = 0; socketCount <  7 ; socketCount++ )
 {
 if( socketInUse[socketCount] !=  ((void *)0)  )
 {
 socketInUse[socketCount]->alive_time++;
 }
 }

  Net_Ethernet_Intern_userTimerSec ++;
 ntp_epoch_time++;

}
#line 2064 "C:/Projects/WebServer/websvr.c"
int8_t webserver_add_staticpage( const char* page, char* page_name, long page_size )
{
 if( page_number ==  17  )
 {
 return -1;
 }

 else
 {
 char* p_file_extension;
 int extension_index;
 char* txt_buffer[12];


 strcpy( pages[page_number].page_name, page_name );

 LongToStr( page_size, txt_buffer );
 strcpy( pages[page_number].page_size_str, Ltrim( txt_buffer ) );

 p_file_extension = strchr( page_name, '.' );
 p_file_extension++;


 for( extension_index = 0; extension_index < HTTP_UNKNOWN; extension_index++ )
 {
 if( strncmp_const( p_file_extension, http_file_extensions[extension_index], 3 ) == 0 )
 {
 pages[page_number].page_type = extension_index;
 }
 }


 pages[page_number].static_page_flag =  1 ;

 pages[page_number].static_page.start_ptr = page;
 pages[page_number].static_page.current_ptr = page;
 pages[page_number].static_page.end_ptr = page + page_size;

 return page_number++;
 }
}
#line 2117 "C:/Projects/WebServer/websvr.c"
int8_t webserver_add_dynamicpage( char* const page, char* page_name, void ( *page_upd_callback )( void ) )
{
 if( page_number ==  17  )
 {
 return -1;
 }

 else
 {
 char* p_file_extension;
 int extension_index;
 char txt_buffer[12];


 strcpy( pages[page_number].page_name, page_name );

 LongToStr( strlen( page ), txt_buffer );
 strcpy( pages[page_number].page_size_str, Ltrim( txt_buffer ) );

 p_file_extension = strchr( page_name, '.' );
 p_file_extension++;


 for( extension_index = 0; extension_index < HTTP_UNKNOWN; extension_index++ )
 {
 if( strncmp_const( p_file_extension, http_file_extensions[extension_index], 3 ) == 0 )
 {
 pages[page_number].page_type = extension_index;
 }
 }


 pages[page_number].static_page_flag =  0 ;

 pages[page_number].dynamic_page.start_ptr = page;
 pages[page_number].dynamic_page.current_ptr = page;
 pages[page_number].dynamic_page.end_ptr = page + strlen( page );
 pages[page_number].dynamic_page.page_update = page_upd_callback;

 return page_number++;
 }
}
#line 2167 "C:/Projects/WebServer/websvr.c"
int8_t webserver_init( struct webserver_config_t* config )
{

 http_port = config->port;
 ntp_epoch_time= config->epochTime;
 form_received = config->form_key_values;
 file_download = config->file_download;
 ntp_received = config->ntp_time;
 irqModeEnable = config->irq_enable;

 packet_flag =  1 ;

  Net_Ethernet_Intern_stackInitTCP ();
#line 2207 "C:/Projects/WebServer/websvr.c"
 if(  Net_Ethernet_Intern_Init ( config->myMacAddr,
 config->myIpAddr,
  0b10000  |  0b10 ,
 &_GPIO_MODULE_ETHERNET ) == 1 )
 {
 return -1;
 }
#line 2228 "C:/Projects/WebServer/websvr.c"
  Net_Ethernet_Intern_confNetwork(config->ipMask, config->gwIpAddr, config->dnsIpAddr) ;



 if( irqModeEnable ==  1  )
 {

 Ethernet_DMA_DMAIER |= ( 1 << NISE ) | ( 1 << RIE );
 NVIC_IntEnable( IVT_INT_ETH );
 }

 {
 int regValue = 0;
 const char _PHY_BSR = 1;


 while( !( regValue & 0b100 ) )
 {
 Net_Ethernet_Intern_PHY_Read( _PHY_BSR, &regValue );
 }
 }







 {
 int socketCount;
 socket_t* soc;


 for( socketCount = 0; socketCount <  7 ; socketCount++ )
 {
 soc = &sockets[socketCount];
 stack_push( socketStack, soc );
 }

 server_request.eth_socket_download =  ((void *)0) ;
 server_request.request_send_flag =  0 ;
 server_request.capture_length = 0;

 }

 return 0;
}
#line 2288 "C:/Projects/WebServer/websvr.c"
void webserver_cleanup()
{
 int socketCount;

 for( socketCount = 0; socketCount <  7 ; socketCount++ )
 {
 if( socketInUse[socketCount] !=  ((void *)0)  )
 {
 if( ( socketInUse[socketCount]->eth_socket->state == 0 )
 || ( socketInUse[socketCount]->alive_time >  10  ) )
 {
 close_socket( socketInUse[socketCount] );
 }
 }
 }

 update_GMT_str( &GMT_string );

}
#line 2312 "C:/Projects/WebServer/websvr.c"
void webserver_read_packet()
{
  Net_Ethernet_Intern_doPacket ();

 if( ( server_request.eth_socket_download->state == 3 ) && ( server_request.request_send_flag ==  1  ) )
 {
 if(  Net_Ethernet_Intern_startSendTCP ( server_request.eth_socket_download ) == 1 )
 {
 server_request.request_send_flag =  0 ;
 }
 }


 bar_graph_display( (  7 -1 ) - stackTop );


}
#line 2335 "C:/Projects/WebServer/websvr.c"
void webserver_print_status( void )
{
 char txtBuffer[50];
 int count;
 socket_t* mySocket;

 if( server_request.eth_socket_download !=  ((void *)0)  )
 {
 sprinti( txtBuffer, "***\r\n\nState of download socket: %u ***\r\n", ( int )server_request.eth_socket_download->state );
  UART1_Write_Text(txtBuffer) ;
 }

}
#line 2354 "C:/Projects/WebServer/websvr.c"
void packet_ISR() iv  IVT_INT_ETH  ics ICS_AUTO
{
#line 2386 "C:/Projects/WebServer/websvr.c"
 if( Ethernet_DMA_DMASR & ( 1 << NIS ) )
 {

 if( Ethernet_DMA_DMASR & ( 1 << RS ) )
 {
 packet_flag =  1 ;
 Ethernet_DMA_DMASR |= ( 1 << RS );
 }

 Ethernet_DMA_DMASR |= ( 1 << NIS );
 }


}
